#!/usr/bin/perl

use CGI qw(:standard);

$ADDRESSBOOK="/usr/local/etc/sms/sms_addressbook";
$SMS_CLIENT="/usr/local/bin/sms_client -l 4";
$title = "Mobile Phone Text Messaging";

my @vals;
$!++;		# Turn off block buffering to STDOUT

my $jscript=<<JSCRIPT
  function calcCharsLeft(form) {
    clipped = false;
    maxLength = 150;
    if (form.message.value.length > maxLength) {
      form.message.value = form.message.value.substring(0, maxLength);
      charsLeft = 0;
      clipped = true;
    } else {
      charsLeft = maxLength - form.message.value.length;
    }
    form.msgCL.value = charsLeft;
    return clipped;
  }

  function textKey(form) {
    supportsKeys = true
    calcCharsLeft(form)
  }

  function checkSend(form)
  {
    if (form.message.value.length < 2) {
      window.alert("Please enter a message");
      form.message.focus();
      return(false);
    }
    if (form.recipients.selectedIndex == -1) {
      window.alert("Please select a recipient");
      form.recipients.focus();
      return(false);
    }
    form.submit.value = "Please Wait...";
    form.submit.disabled = true;
    return(true);
  }
JSCRIPT
;

$query = new CGI;

unless ($query->param) {
    print $query->header,
    	start_html(-title=>$title,
                       -script=>$jscript,
                       -onload=>"document.forms[0].message.focus();"),
	h1($title);
    &getnums;
    print $query->start_form( -name=>"Input",
                             -onSubmit=>"return(checkSend(this))");
    print <<HTML
  Enter your message here, <b>include your name so the recipient knows who 
  sent it!</b>:<hr>
  <textarea name="message" rows="5" cols="40" wrap="soft"
            onKeyUp="textKey(this.form)"></textarea>
  <br>
  <input value="150" size="3" name="msgCL" onKeyDown="return false">&nbsp;characters&nbsp;left
HTML
    ;
	
    print $query->hr("Select the recipients (use the Control key to pick several). <b>Recipient must be in the UK.</b>");
    print $query->p;
    print $query->scrolling_list(
	-name=>'recipients',
	-values =>\@vals,
	-size=>8,
	-multiple=>'true');
    print "<br>\n";
    print "<br>\n";
    print $query->submit(-value=>'Send Message',
                         -name=>'submit');
    print $query->end_html;
} else {
    print $query->header,
    	start_html(-title=>$title,
                   -script=>$jscript),
	h1($title);
    @names = $query->param;
    $message = $query->param('message');

    $message =~ s/'/'\\''/g;         # workaround for single quotes
    $message =~ s/\r//gm;            # replace charage returns with spaces
    $message =~ s/\n/ /gm;           # replace new lines with spaces
    @recipients = $query->param('recipients');
    $recipientlist = join(",", @recipients);
    $recipientlist =~ s/\s//go;
    print "Sending message '$message' to: $recipientlist";
    print p;

    # Do the sending
    $sent_ok = 0;
    @log = "";
    $cmd = "$SMS_CLIENT $recipientlist '$message'";
    print "<!-- Running $cmd -->\n";
    open (SYS, "$cmd|");
    while (<SYS>) {
        if (/^\[000\]/) {
            $sent_ok = 1;
        }
        @log = (@log, $_);
    }
    close(SYS);

    if ($sent_ok) {
        print h3 "Sent OK"
    } else {
        print h3 "NOT SENT";
    }
    print b("Log");
    foreach my $line (@log) {
        print "<br>$line\n";
    }
    print $query->end_html;
}

sub getnums
{
    open(SMSRC, "<$ADDRESSBOOK") || die ("Cannot open $ADDRESBOOK: $!");
    my $in_addresses = 0;
    while (<SMSRC>) {
        chomp;
        $_ =~ s/#.*$//;       # Delete all comments
        
        if ($in_addresses) {
            if (/=/) {
                my($name,$rest) = split("=");
                push(@vals, $name);
            }
        } else {
            if (/^\s*{\s*$/) {
                $in_addresses = 1;
            }
            next;
        }
            
    }
}
